<?
/*******************************************************************************

    MSC - Version 0.1 vom 23.04.2017

********************************************************************************

    SKRIPT ZUM AUSWERTEN VON Fronius Wechselrichter
    mit aktivem Push-Service über IPS-Webhook
	
--------------------------------------------------------------------------------

	INSTALLATIONSSKRIPT

********************************************************************************
*******************************************************************************/

	$inverter = true;
	$powerflow = true;
	$smartmeter = true;
	$storage = false;
	$iostate = true;
	$logdata = false;
	$logerror = true;


/*******************************************************************************
*******************************************************************************/

// Profile anlegen
// ----------------
	create_profil("_PV_Voltage", 1, 0, 405, 1, 0, "", " V", "Speedo", "");
	create_profil("_PV_Current", 2, 0, 100, 0.5, 2, "", " A", "Speedo", "");
	create_profil("_PV_Watt", 1, -5000, 5000, 1, 0, "", " W", "Intensity", "");
	create_profil("_PV_kWh", 1, 0, 0, 1, 0, "", " kWh", "Intensity", "");
	create_profil("_PV_VA", 1, -3000, 3000, 1, 0, "", " VA", "Hourglass", "");
	create_profil("_PV_Var", 1, -3000, 3000, 1, 0, "", " Var", "Hourglass", "");
	create_profil("_PV_Hz", 1, 0, 50, 1, 0, "", " Hz", "Fog", "");
	create_profil("_PV_Prozent", 1, 0, 100, 1, 0, "", " %", "Speedo", "");
	create_profil("_PV_Switch", 0, 0, 0, 0, 0, "", "", "Power", array(0 => "aus", 1 => "aktiv"), array(0 => "", 1 => "#00ff00"));


// *****************************************************************************


// Skript anlegen
// ---------------
	$sid_evaluate = CreateScript(IPS_GetParent($_IPS['SELF']), "Auswerten", "pvWR1_Auswerten", 100, "PV_WR1_Auswerten.ips.php");


// *****************************************************************************


// Webhook anlegen
// ----------------
	if($sid_evaluate == true) CreateWebHook("fronius", $sid_evaluate);


// *****************************************************************************


// Inverter Variablen
// -------------------
if($inverter == true){
	$did_inverter = SetDummyByName(IPS_GetParent($_IPS['SELF']), "Wechselrichter", "pvWR1_Inverter", 10, "");
	$pos = 10;
	CreateVariableByName($did_inverter, "Hersteller", "sunSpecInv_Mn", 3, "", $pos++, "Keyboard", "");
	CreateVariableByName($did_inverter, "Model", "sunSpecInv_Md", 3, "", $pos++, "Information", "");
	CreateVariableByName($did_inverter, "Firmware", "sunSpecInv_Vr", 3, "", $pos++, "Information", "");
	CreateVariableByName($did_inverter, "Serial", "sunSpecInv_SN", 3, "", $pos++, "Key", "");
	
	CreateVariableByName($did_inverter, "Status", "sunSpecInv_St", 3, "", $pos++, "Talk", "", true);
	
	CreateVariableByName($did_inverter, "Leistung", "sunSpecInv_W", 1, "_PV_Watt", $pos++, "", "", true);
	
	CreateVariableByName($did_inverter, "Strom L1", "sunSpecInv_I_AC_CurrentA", 2, "_PV_Current", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Strom L2", "sunSpecInv_I_AC_CurrentB", 2, "_PV_Current", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Strom L3", "sunSpecInv_I_AC_CurrentC", 2, "_PV_Current", $pos++, "", "", true);
	
	CreateVariableByName($did_inverter, "Spannung L1", "sunSpecInv_I_AC_VoltageA", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Spannung L2", "sunSpecInv_I_AC_VoltageB", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Spannung L3", "sunSpecInv_I_AC_VoltageC", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Spannung L1-L2", "sunSpecInv_I_AC_VoltageAB", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Spannung L2-L3", "sunSpecInv_I_AC_VoltageBC", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Spannung L3-L1", "sunSpecInv_I_AC_VoltageCA", 1, "_PV_Voltage", $pos++, "", "", true);
	
	CreateVariableByName($did_inverter, "Frequenz", "sunSpecInv_Hz", 1, "_PV_Hz", $pos++, "", "", true);
	
	CreateVariableByName($did_inverter, "Strom DC", "sunSpecInv_DCA", 2, "_PV_Current", $pos++, "", "", true);
	CreateVariableByName($did_inverter, "Spannung DC", "sunSpecInv_DCV", 1, "_PV_Voltage", $pos++, "", "", true);
	
	CreateVariableByName($did_inverter, "Datum", "sunSpecInv_Date", 3, "", $pos++, "Calendar", "");		
	}

// -----------------------------------------------------------------------------

// Powerflow Variablen
// --------------------
if($powerflow == true){
	$did_powerflow = SetDummyByName(IPS_GetParent($_IPS['SELF']), "Produktionsdaten", "pvWR1_PowerFlow", 11, "");
	$pos = 10;
	CreateVariableByName($did_powerflow, "Anlagenleistung", "P_Load", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Netzleistung", "P_Grid", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Produktion aktuell PV", "P_PV", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Produktion aktuell Netz", "P", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Batterieleistung", "P_Akku", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Produktion Tag", "E_Day", 1, "_PV_kWh", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Produktion gesamt", "E_Total", 1, "_PV_kWh", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Produktion Jahr", "E_Year", 1, "_PV_kWh", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Autonomie", "rel_Autonomy", 1, "_PV_Prozent", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Eigenverbrauch", "rel_SelfConsumption", 1, "_PV_Prozent", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Notstrom", "BackupMode", 0, "_PV_Switch", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Batterie-Standby", "BatteryStandby", 0, "_PV_Switch", $pos++, "", "", true);
	CreateVariableByName($did_powerflow, "Datum", "PowerFlow_Date", 3, "", $pos++, "Calendar", "");	
	}

// -----------------------------------------------------------------------------
	
// Smartmeter Variablen
// ---------------------
if($smartmeter == true){
	$did_meter = SetDummyByName(IPS_GetParent($_IPS['SELF']), "Smartmeter", "pvWR1_Meter", 12, "");
	$pos = 10;
	// Herstellerangaben
	CreateVariableByName($did_meter, "Hersteller", "Details_Manufacturer", 3, "", $pos++, "Keyboard", "");
	CreateVariableByName($did_meter, "Model", "Details_Model", 3, "", $pos++, "Information", "");
	CreateVariableByName($did_meter, "Serial", "Details_Serial", 3, "", $pos++, "Key", "");
	// Spannung Phase zu Phase
	CreateVariableByName($did_meter, "Spannung L1-L2", "Voltage_AC_PhaseToPhase_12", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Spannung L2-L3", "Voltage_AC_PhaseToPhase_23", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Spannung L3-L1", "Voltage_AC_PhaseToPhase_31", 1, "_PV_Voltage", $pos++, "", "", true);
	// Spannung Phase zu N
	CreateVariableByName($did_meter, "Spannung L1-N", "Voltage_AC_Phase_1", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Spannung L2-N", "Voltage_AC_Phase_2", 1, "_PV_Voltage", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Spannung L3-N", "Voltage_AC_Phase_3", 1, "_PV_Voltage", $pos++, "", "", true);
	// Frequenz
	CreateVariableByName($did_meter, "Frequenz", "Frequency_Phase_Average", 1, "_PV_Hz", $pos++, "", "", true);
	// Strom
	CreateVariableByName($did_meter, "Strom L1", "Current_AC_Phase_1", 2, "_PV_Current", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Strom L2", "Current_AC_Phase_2", 2, "_PV_Current", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Strom L3", "Current_AC_Phase_3", 2, "_PV_Current", $pos++, "", "", true);
	// Wirkarbeit Netz
	CreateVariableByName($did_meter, "Wirkarbeit konsumiert", "EnergyReal_WAC_Sum_Consumed", 1, "_PV_kWh", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Wirkarbeit erzeugt", "EnergyReal_WAC_Sum_Produced", 1, "_PV_kWh", $pos++, "", "", true);
	// Blindleistung Netz
	CreateVariableByName($did_meter, "Blindleistung konsumiert", "EnergyReactive_VArAC_Sum_Consumed", 1, "_PV_Var", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Blindleistung erzeugt", "EnergyReactive_VArAC_Sum_Produced", 1, "_PV_Var", $pos++, "", "", true);
	// Wirkleistung Wechselrichter
	CreateVariableByName($did_meter, "Wirkleistung L1", "PowerReal_P_Phase_1", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Wirkleistung L2", "PowerReal_P_Phase_2", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Wirkleistung L3", "PowerReal_P_Phase_3", 1, "_PV_Watt", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Wirkleistung gesamt", "PowerReal_P_Sum", 1, "_PV_Watt", $pos++, "", "", true);
	// Scheinleistung Wechselrichter
	CreateVariableByName($did_meter, "Scheinleistung L1", "PowerApparent_S_Phase_1", 1, "_PV_VA", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Scheinleistung L2", "PowerApparent_S_Phase_2", 1, "_PV_VA", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Scheinleistung L3", "PowerApparent_S_Phase_3", 1, "_PV_VA", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Scheinleistung gesamt", "PowerApparent_S_Sum", 1, "_PV_VA", $pos++, "", "", true);
	// Blindleistung Wechselrichter
	CreateVariableByName($did_meter, "Blindleistung L1", "PowerReactive_Q_Phase_1", 1, "_PV_Var", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Blindleistung L2", "PowerReactive_Q_Phase_2", 1, "_PV_Var", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Blindleistung L3", "PowerReactive_Q_Phase_3", 1, "_PV_Var", $pos++, "", "", true);
	CreateVariableByName($did_meter, "Blindleistung gesamt", "PowerReactive_Q_Sum", 1, "_PV_Var", $pos++, "", "", true);
	// cosPhi Wechselrichter
	CreateVariableByName($did_meter, "cosPhi L1", "PowerFactor_Phase_1", 2, "", $pos++, "Graph", "", true);
	CreateVariableByName($did_meter, "cosPhi L2", "PowerFactor_Phase_2", 2, "", $pos++, "Graph", "", true);
	CreateVariableByName($did_meter, "cosPhi L3", "PowerFactor_Phase_3", 2, "", $pos++, "Graph", "", true);
	CreateVariableByName($did_meter, "cosPhi gesamt", "PowerFactor_Sum", 2, "", $pos++, "Graph", "", true);
	// Zeitstempel der Daten
	CreateVariableByName($did_meter, "Datum", "TimeStamp", 3, "", $pos++, "Calendar", "");
	}

// -----------------------------------------------------------------------------

// Storage Variablen
// ------------------
if($storage == true){
	$did_storage = SetDummyByName(IPS_GetParent($_IPS['SELF']), "IO Status", "pvWR1_Storage", 13, "");
	$pos = 10;

	}

// -----------------------------------------------------------------------------

// IO-State Variablen
// -------------------
if($iostate == true){
	$did_iostate = SetDummyByName(IPS_GetParent($_IPS['SELF']), "IO Status", "pvWR1_IOState", 14, "");
	$pos = 10;
	CreateVariableByName($did_iostate, "Ausgang-0: Notstrom Verriegelung", "io_pin0", 0, "_PV_Switch", $pos++, "", "", true);
	CreateVariableByName($did_iostate, "Eingang-4: Notstrom Anforderung", "io_pin4", 0, "_PV_Switch", $pos++, "", "", true);
	}
	
// -----------------------------------------------------------------------------
	
// LogData Variablen
// ------------------
if($logdata == true){
	$did_logdata = SetDummyByName(IPS_GetParent($_IPS['SELF']), "Archiv", "pvWR1_logData", 15, "");
	$pos = 10;

	}	
	
// -----------------------------------------------------------------------------
	
// LogError Variablen
// -------------------
if($logerror == true){
	$did_logerror = SetDummyByName(IPS_GetParent($_IPS['SELF']), "Fehler", "pvWR1_logError", 16, "");
	$pos = 10;
	CreateVariableByName($did_logerror, "Fehlerübersicht", "logError_Box", 3, "~HTMLBox", $pos++, "Warning", "");
	CreateVariableByName($did_logerror, "Datum", "logError_Date", 3, "", $pos++, "Calendar", "");
	}	
		

// *****************************************************************************

// Installation Skript_Contents
// -----------------------------
$content_evaluate = '<?
/*******************************************************************************

    MSC - Version 0.1 vom 23.04.2017

********************************************************************************

    SKRIPT ZUM AUSWERTEN VON Fronius Wechselrichter
    mit aktivem Push-Service über IPS-Webhook
	
--------------------------------------------------------------------------------

	Auswerteskript

********************************************************************************
*******************************************************************************/
	
	// Parents ermitteln
	$deviceID = IPS_GetParent($_IPS[\'SELF\']);
		$did_inverter = IPS_GetObjectIDByIdent("pvWR1_Inverter", $deviceID);
		$did_powerflow = IPS_GetObjectIDByIdent("pvWR1_PowerFlow", $deviceID);
		$did_meter = IPS_GetObjectIDByIdent("pvWR1_Meter", $deviceID);
		//$did_storage = IPS_GetObjectIDByIdent("pvWR1_Storage", $deviceID);
		$did_iostates = IPS_GetObjectIDByIdent("pvWR1_IOState", $deviceID);
		//$did_logdata = IPS_GetObjectIDByIdent("pvWR1_logData", $deviceID);
		$did_logerror = IPS_GetObjectIDByIdent("pvWR1_logError", $deviceID);
	
// -----------------------------------------------------------------------------

	$status_codes = array(
				1 => "Wechselrichter ist aus",
				2 => "Wechselrichter Auto-Shutdown",
				3 => "Wechselrichter startet",
				4 => "Wechselrichter arbeitet normal",
				5 => "Leistungsreduktion aktiv",
				6 => "Wechselrichter schaltet ab",
				7 => "Fehler vorhanden",
				8 => "Standby",
				9 => "keine SolarNet Kommunikation",
				10 => "keine Kommunikation mit Wechselrichter",
				11 => "Überstrom am SolarNet-Stecker",
				12 => "Update des Wechselrichters läuft",
				13 => "AFCI Event (Arc-Erkennnung)"
				);

/*******************************************************************************
*******************************************************************************/

// Empfangene Daten zuordnen
if($_IPS[\'SENDER\'] == "WebHook"){
	$hook_sender = "";
	
	$content = file_get_contents("php://input");

	// prüfen auf Fronius JSON
	if(json_decode($content, true)){
		$data = json_decode($content, true);
	
		if(array_key_exists("Inverters", $data[\'Body\'])) $hook_sender = "powerflow";
		elseif(array_key_exists("states", $data)) $hook_sender = "states";
		elseif($data[\'Head\'][\'RequestArguments\'][\'Query\'] == "Meter") $hook_sender = "meter";
		elseif($data[\'Head\'][\'RequestArguments\'][\'Query\'] == "Inverter+SensorCard+Meter") $hook_sender = "logData";
		elseif($data[\'Head\'][\'RequestArguments\'][\'Query\'] == "Errors+Events") $hook_sender = "logError";
		}
	else{	// SunSpec XML
		$xml = new SimpleXMLElement($content);
		$xml_Excerpt = $xml->xpath("d/m/p");
		$json = json_decode(json_encode($xml_Excerpt), true);

		$data[\'Date\'] = (string)$xml->d->attributes()->t;
		foreach($json as $key => $value){
			$skey = (string)$value[\'@attributes\'][\'id\'];
			$data[\'Values\'][$skey] = $value[0];
			}
		$hook_sender = "inverter";
		}

// *****************************************************************************
	IPS_LogMessage("PV_Auswertung", $hook_sender);
	
	switch($hook_sender){
		
// *****************************************************************************
// Auslöser WebHook - Inverter
// -----------------------------------------------------------------------------
		case "inverter":	// Inverter
			foreach($data[\'Values\'] as $key => $value){
				if(preg_match("/Voltage/", $key)) SetVariable($did_inverter, "sunSpecInv_".$key, round($value, 0), true);
				elseif(preg_match("/Current/", $key)) SetVariable($did_inverter, "sunSpecInv_".$key, round($value, 2), true);
				elseif(preg_match("/Hz/", $key)) SetVariable($did_inverter, "sunSpecInv_".$key, round($value, 0), true);
				elseif($key == "DCA") SetVariable($did_inverter, "sunSpecInv_".$key, round($value, 2), true);
				elseif($key == "DCV") SetVariable($did_inverter, "sunSpecInv_".$key, round($value, 0), true);
				elseif($key == "St") SetVariable($did_inverter, "sunSpecInv_".$key, $status_codes[$value], true);
				else SetVariable($did_inverter, "sunSpecInv_".$key, $value, true);
				}
			SetVariable($did_inverter, "sunSpecInv_Date", date("d.m.Y H:i:s", strtotime($data[\'Date\'])), true);
			IPS_LogMessage("PV_Auswertung", "Inverterdaten abgearbeitet");
		break;

// *****************************************************************************
// Auslöser WebHook - Powerflow
// -----------------------------------------------------------------------------
		case "powerflow":
			foreach($data[\'Body\'][\'Inverters\'][1] as $key => $value){
				if($key == "P") SetVariable($did_powerflow, $key, $value, true);
				}

			foreach($data[\'Body\'][\'Site\'] as $key => $value){
				if(preg_match("/P/", $key)) SetVariable($did_powerflow, $key, $value, true);
				elseif(preg_match("/rel/", $key)) SetVariable($did_powerflow, $key, $value, true);
				elseif(preg_match("/B/", $key)) SetVariable($did_powerflow, $key, $value, true);
				else SetVariable($did_powerflow, $key, round($value / 1000, 0), true);
				}
			SetVariable($did_powerflow, "PowerFlow_Date", date("d.m.Y H:i:s", strtotime($data[\'Head\'][\'Timestamp\'])), true);
			IPS_LogMessage("PV_Auswertung", "Powerflowdaten abgearbeitet");
		break;


// *****************************************************************************
// Auslöser WebHook - Smartmeter
// -----------------------------------------------------------------------------
		case "meter":
			foreach($data[\'Body\'][0] as $key => $value){
				if(is_array($value)){
					foreach($value as $dkey => $dvalue){
						SetVariable($did_meter, $key."_".$dkey, $dvalue, true);
						}
					}
				elseif($key == "TimeStamp") SetVariable($did_meter, $key, date("d.m.Y H:i:s", $value), true);
				elseif(preg_match("/EnergyReal/", $key)) SetVariable($did_meter, $key, round($value / 1000, 0), false, true);
				elseif(preg_match("/(Factor|Current)/", $key)) SetVariable($did_meter, $key, round($value, 2), true);
				elseif(is_float($value)) SetVariable($did_meter, $key, round($value, 0), true);
				else SetVariable($did_meter, $key, $value, true);
				}
			IPS_LogMessage("PV_Auswertung", "Meterdaten abgearbeitet");
		break;
	
	
// *****************************************************************************
// Auslöser WebHook - Storage
// -----------------------------------------------------------------------------
		case "storage":
	
		break;
		
				
// *****************************************************************************
// Auslöser WebHook - IO-State
// -----------------------------------------------------------------------------
		case "states":
			foreach($data[\'states\'] as $key => $value){
				if(is_array($value)){
					SetVariable($did_iostates, "io_".str_replace(\' \', \'\', $key), $value[\'set\'], true);
					}
				}
			IPS_LogMessage("PV_Auswertung", "IOStatedaten abgearbeitet");
		break;


// *****************************************************************************
// Auslöser WebHook - Log -> Data
// -----------------------------------------------------------------------------
		case "logData":
	
		break;


// *****************************************************************************
// Auslöser WebHook - Log -> Error
// -----------------------------------------------------------------------------
		case "logError":
			$htmlBox = "";
			
			$array = $data[\'Body\'][\'inverter/1\'][\'Data\'][\'InverterErrors\'];
			if(count($array) > 1){
				foreach($array as $key => $value){
					if($value[\'Values\'] !== "") $htmlBox .= $value[\'Values\']."<br>";
					}
				}
			elseif($array[\'Values\'] !== "") $htmlBox = $array[\'Values\'];
			
			if($htmlBox !== NULL) SetVariable($did_logerror, "logError_Box", "keine Fehler", true);
			else SetVariable($did_logerror, "logError_Box", $htmlBox, true);
			
			SetVariable($did_logerror, "logError_Date", date("d.m.Y H:i:s", strtotime($data[\'Head\'][\'Timestamp\'])), true);
			IPS_LogMessage("PV_Auswertung", "Errordaten abgearbeitet");
		break;
	
	
// *****************************************************************************	
		default:
			return;
		break;
		}
	}


/*******************************************************************************
********************************************************************************

    FUNKTIONEN

********************************************************************************
*******************************************************************************/

// Funktion schreiben der Variablen
// ---------------------------------
function SetVariable($parentID, $ident, $newvalue, $check = false, $logging = false){
	$vid = @IPS_GetObjectIDByIdent($ident, $parentID);
	$oldvalue = GetValue($vid);

	if($vid !== false){
    	if($logging == true){
			if($newvalue > $oldvalue) SetValue($vid, $newvalue);
			}
		elseif($check == true){
			if($newvalue != $oldvalue) SetValue($vid, $newvalue);
       		}
    	else SetValue($vid, $newvalue);
		}
    }
	
/*******************************************************************************
*******************************************************************************/	
	
?>';

	IPS_SetScriptContent($sid_evaluate, $content_evaluate);


/*******************************************************************************
********************************************************************************

    FUNKTIONEN

********************************************************************************
*******************************************************************************/

// Funktion Dummy erstellen
// -----------------------------------------------------------------------------
function SetDummyByName($parentID, $name, $ident, $position, $icon, $check = false){
    $did = @IPS_GetObjectIDByIdent($ident, $parentID);
    if($did === false){
    	$did = @IPS_CreateInstance("{485D0419-BE97-4548-AA9C-C083EB82E61E}");
        IPS_SetName($did, $name);
        IPS_SetIdent($did, $ident);
        IPS_SetParent($did, $parentID);
        IPS_SetPosition($did, $position);
        IPS_SetIcon($did, $icon);
        }

    if($check){
        if($name != IPS_GetObject($did)['ObjectName'])IPS_SetName($did, $name);
        if($position != IPS_GetObject($did)['ObjectPosition'])IPS_SetPosition($did, $position);
        }
    return $did;
    }  


// Funktion Skript erstellen
// -----------------------------------------------------------------------------
function CreateScript($parentID, $name, $ident, $position, $file = ""){		
	$sid = @IPS_GetScriptIDByName($name, $parentID);
	
	if($sid === false){
    	$sid = IPS_CreateScript(0);
		IPS_SetParent($sid, $parentID);
        IPS_SetPosition($sid, $position);
        IPS_SetName($sid, $name);
        IPS_SetIdent($sid, $ident);
			
		if($file !== ""){
			$script = IPS_GetScript($sid);
			rename(IPS_GetKernelDir().'/scripts/'.$script['ScriptFile'], IPS_GetKernelDir().'/scripts/'.$file.'.ips.php');
			IPS_SetScriptFile($sid, $file.".ips.php");
			}
        }
	return $sid;
	}	
	

// Funktion Variable erstellen
// -----------------------------------------------------------------------------
function CreateVariableByName($parentID, $name, $ident, $type, $profil, $pos, $icon, $script, $logging = false, $check = false){
    $vid = @IPS_GetObjectIDByIdent($ident, $parentID);

       if($vid === false){
        $vid = IPS_CreateVariable($type);
           IPS_SetParent($vid, $parentID);
           IPS_SetName($vid, $name);
           IPS_SetIdent($vid, $ident);
		   IPS_SetIcon($vid, $icon);
           IPS_SetVariableCustomProfile($vid, $profil);
           if($script !== "") IPS_SetVariableCustomAction($vid, $script);
           IPS_SetPosition($vid, $pos);
            
        if($logging == true){
        	$archivID = IPS_GetInstanceListByModuleID("{43192F0B-135B-4CE7-A0A7-1475603F3060}")[0];

            AC_SetAggregationType($archivID, $vid, 0);
            AC_SetGraphStatus($archivID, $vid, true);
            AC_SetLoggingStatus($archivID, $vid, true);
            @IPS_ApplyChanges($archivID);
            }
        }
    if($check){
        if($name != IPS_GetObject($vid)['ObjectName'])IPS_SetName($vid, $name);
        if($pos != IPS_GetObject($vid)['ObjectPosition'])IPS_SetPosition($vid, $pos);
        }
      return $vid;
    }


// Funktion Variablenprofil erstellen
// -----------------------------------------------------------------------------
function create_profil($profil, $typ, $min, $max, $step, $digits, $pre, $suf, $icon, $asso, $color = false){
 $data = @IPS_GetVariableProfile($profil);

    if($data == true){
        // Einträge löschen
        foreach($data['Associations'] as $key => $array){
            @IPS_SetVariableProfileAssociation($profil, $key, "", "", -1);
   			@IPS_SetVariableProfileValues($profil, 0, 0, 0);
			@IPS_SetVariableProfileDigits($profil, 0);
			@IPS_SetVariableProfileIcon($profil, "");
            }
        }
    else{
        IPS_CreateVariableProfile($profil, $typ);
        IPS_SetVariableProfileValues($profil, $min, $max, $step);
        }

// -----------------------------------------------------------------------------

   // neue Einträge erstellen
   	IPS_SetVariableProfileValues($profil, $min, $max, $step);
	IPS_SetVariableProfileDigits($profil, $digits);
	IPS_SetVariableProfileIcon($profil, $icon);
		
    if(is_array($asso) == true){
        foreach($asso as $key => $value){
           IPS_SetVariableProfileText($profil, $pre, $suf);
           if($color == false){
                @IPS_SetVariableProfileAssociation($profil, $key, $value, "", -1);
               }
            else{
                @IPS_SetVariableProfileAssociation($profil, $key, $value, "", hexdec($color[$key]));
               }
            }
        }
    else{
       IPS_SetVariableProfileText($profil, $pre, $suf);
       if($color == false){
              @IPS_SetVariableProfileAssociation($profil, 0, $asso, "", -1);
              }
       else{
              @IPS_SetVariableProfileAssociation($profil, 0, $asso, "", hexdec($color));
              }
        }
    }


// Funktion ScriptTimer erstellen
// -----------------------------------------------------------------------------
function SetScriptTimerByName($scriptID, $ident, $position, $value){
   $tid = @IPS_GetObjectIDByIdent($ident, $scriptID);

    if($tid === false){
    	IPS_SetScriptTimer($scriptID, $value);
		$tid = IPS_GetEventIDByName("ScriptTimer", $scriptID);

		IPS_SetIdent($tid, $ident);
		IPS_SetPosition($tid, $position);
        }
    return $tid;
    }


// Funktion WebHook erstellen
// -----------------------------------------------------------------------------
function CreateWebHook($hook, $targetID){
	$hookID  = IPS_GetInstanceListByModuleID('{015A6EB8-D6E5-4B93-B496-0D3F77AE9FE1}')[0];
	$hooks = json_decode(IPS_GetProperty($hookID, "Hooks"), true);
	
	$hook_found = false;
	foreach($hooks as $key => $value){
		if($value['Hook'] == "/hook/".$hook){
			$hook_found = true;
			$hooks[$key]['TargetID'] = $targetID;
			}
		}

	if($hook_found !== true){
		$newhook['TargetID'] = $targetID;
		$newhook['Hook'] = "/hook/".$hook;
		
		$hooks[] = $newhook;
		}

	IPS_SetProperty($hookID, "Hooks", json_encode($hooks));
	IPS_ApplyChanges($hookID);
    }
	
/*******************************************************************************
*******************************************************************************/

?>